<script lang="ts">
  import { send, receive } from "./cardTransition";
  import Card from "./Card.svelte";

  export let cards: CardId[];
  export let facedown: boolean = false;
  export let clickable: boolean = false;
  export let showCount: boolean = false;

  $: renderedCards = cards.slice(Math.max(0, cards.length - 6));
</script>

<div class="pile" class:clickable disabled={!clickable}>
  {#each renderedCards as card, idx (card)}
    {@const offset = -idx * 2 + "px"}

    <div
      class="card"
      style:--translate-card-x={offset}
      style:--translate-card-y={offset}
    >
      <div in:receive={{ key: card }} out:send={{ key: card }}>
        {#if idx < renderedCards.length - 1}
          <Card {card} {facedown} />
        {:else}
          <button class="invisibutton" disabled={!clickable} on:click>
            <Card {card} {facedown} />
          </button>
        {/if}

        {#if cards.length > 0 && showCount}
          <div class="pile-size">
            &times; {cards.length}
          </div>
        {/if}
      </div>
    </div>
  {/each}
</div>

<style lang="scss">
  .pile {
    height: 10em;
    width: 10em;
    position: relative;
  }

  .pile::before {
    content: "";
    position: absolute;
    inset: 1px;
    border: 3px dashed #0003;
    border-radius: 2px;
  }

  .card {
    position: absolute;
    top: 0;
    left: 0;
    transform: translateX(var(--translate-card-x))
      translateY(var(--translate-card-y));
  }

  button {
    transition: transform 0.2s;

    &:not(:disabled) {
      cursor: pointer;
      &:hover,
      &:focus {
        transform: translateY(-10%);
      }
    }
  }

  .pile-size {
    font-size: 250%;
    font-weight: bolder;
    white-space: nowrap;
    color: white;
    filter: drop-shadow(0 0 1px #007);
    pointer-events: none;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
